dnl	macro to determine whether or not a module can be loaded
dnl requires a relatively new version of automake, not sure how new, as the
dnl macro below relies on AM_PATH_PYTHON being called.
dnl
dnl $Id: python_modules.m4,v 1.1.1.1 2004/08/20 19:00:01 commit Exp $

dnl PY_CHECK_MODULES(MODULE [, SYMBOL [, ACTION-IF-FOUND [, ACTION-IF-NOT-FOUND]]])
dnl check if a module with said symbol is visible to python
dnl we do some name mangling to automatically create the output variables
dnl all "."s are converted to "_"s.
AC_DEFUN([PY_CHECK_MODULES],
[AC_REQUIRE([AM_PATH_PYTHON])
py_mod_var=`echo $1_$2 | sed 'y%./+-%__p_%'`
AC_MSG_CHECKING(for ifelse([$2],[],,[$2 in ])python module $1)
AC_CACHE_VAL(py_cv_mod_$py_mod_var, [
ifelse([$2],[], [prog="
import sys
try:
        import $1
except ImportError:
        sys.exit(1)
except:
        sys.exit(0)
sys.exit(0)"], [prog="
import sys
try:
	import $1
	
	try:
		$1.$2
	except AttributeError:
		try:
			import $1.$2
		except ImportError:
			sys.exit(1)
		sys.exit(0)

	sys.exit(0)
except ImportError:
	sys.exit(1)"])
if $PYTHON -c "$prog" 1>&AC_FD_CC 2>&AC_FD_CC
  then
    eval "py_cv_mod_$py_mod_var=yes"
  else
    eval "py_cv_mod_$py_mod_var=no"
  fi
])
py_val=`eval "echo \`echo '$py_cv_mod_'$py_mod_var\`"`
if test "x$py_val" != xno; then
  AC_MSG_RESULT(yes)
  ifelse([$3], [],, [$3
])dnl
else
  AC_MSG_RESULT(no)
  AC_MSG_ERROR([I was unable to find the Python module 'ifelse([$2],[], [$1], [$1.$2])'.  Please read the README file to find out how to install it.])
  ifelse([$4], [],, [$4
])dnl
fi
])
