dnl	maros to find various python extensions
dnl requires a relatively new version of automake, not sure how new, as the
dnl macros below rely on AM_PATH_PYTHON being called.
dnl
dnl $Id: python_numeric.m4,v 1.1.1.1 2004/08/20 19:00:01 commit Exp $

AC_DEFUN(NA_MOD_NUMERIC,
[AC_REQUIRE([NA_MOD_NUMERIC_PATH])
if test "n$na_mod_numeric_path"; then
	NA_MOD_NUMERIC_IMPORT
fi
])

AC_DEFUN(NA_MOD_NUMARRAY,
[AC_REQUIRE([NA_MOD_NUMARRAY_PATH])
if test "n$na_mod_numarray_path"; then
	NA_MOD_NUMARRAY_IMPORT
fi
])

AC_DEFUN(PY_HAVE_NUMERIC_OR_NUMARRAY,
[if test "x$py_cv_mod_Numeric_" = "no" -a "x$py_cv_mod_numarray_" = "no"; then
	AC_MSG_ERROR([You need either Numeric or numarray to use $PACKAGE.])
fi
if test "x$py_cv_mod_Numeric_" = "xyes" && test "x$py_cv_mod_numarray_" = "xyes"; then
	AC_MSG_RESULT([found both Numeric and numarray, using numarray])
	AC_SUBST([FROI_USE_NUMARRAY], [1])
elif test "x$py_cv_mod_Numeric_" = "xno" && test "x$py_cv_mod_numarray_" = "xyes"; then
	AC_MSG_RESULT([found numarray, using numarray])
	AC_SUBST([FROI_USE_NUMARRAY], [1])
elif test "x$py_cv_mod_Numeric_" = "xyes" && test "x$py_cv_mod_numarray_" = "xno"; then
	AC_MSG_RESULT([found Numeric, using Numeric])
	AC_SUBST([FROI_USE_NUMARRAY], [0])
else
	AC_MSG_ERROR([huh, didn't do something that we should have.  This shouldn't happen.  Send the output of this command to $PACKAGE_BUGREPORT])
fi
])
AC_DEFUN(NA_MOD_MATPLOTLIB,
[AC_REQUIRE([NA_MOD_MATPLOTLIB_PATH])
if test "n$na_mod_MATPLOTLIB_path"; then
	NA_MOD_MATPLOTLIB_IMPORT
fi
])

dnl see if the numarray directory exists under "site-packages"
AC_DEFUN([NA_MOD_NUMARRAY_PATH],
[na_mod_numarray_dir=
AC_ARG_WITH([numarray-path], 
AC_HELP_STRING([--with-numarray-path=PATH], [use PATH as the top-level directory for numarray [[$(python_prefix)/site-packages/numarray]]]),
[AC_MSG_CHECKING([for top-level numarray directory])
if test "d$withval"; then
	AC_MSG_RESULT([$withval])
	numarray_path=$withval
	AC_SUBST([numarray_path])
else
	AC_MSG_ERROR([given numarray path $withval does not exist.])
fi])
AC_MSG_CHECKING([for top-level numarray directory])
python_module_dir=${pyexecdir:15}
py_exec_prefix=`$PYTHON -c "import sys; print sys.exec_prefix"`
na_mod_numarray_path="$py_exec_prefix/$python_module_dir/numarray"
if test -d $na_mod_numarray_path; then
	AC_MSG_RESULT([$na_mod_numarray_path])
	numarray_path=$na_mod_numarray_path
	AC_SUBST([numarray_path])
else
	echo $na_mod_numarray_path
	AC_MSG_RESULT([not found])
fi])

dnl see if we can actually load the numarray module
AC_DEFUN([NA_MOD_NUMARRAY_IMPORT],
[na_mod_numarray_import=0
AC_MSG_CHECKING([for whether we can "import numarray" or not])
na_mod_numarray_import=`$PYTHON -c "
try:
	import numarray
	print 1
except ImportError:
	print 0"`
if test $na_mod_numarray_import -eq 1; then
	AC_MSG_RESULT([yes])
else
	AC_MSG_ERROR([unable to import numarray])
	echo
	echo "I was unable to import the numarray library, even though the"
	echo "correct directory seems to exist.  Check the output of config.log"
	echo "for more information."
fi])

dnl see if the Numeric directory exists under "site-packages"
AC_DEFUN([NA_MOD_NUMERIC_PATH],
[na_mod_numeric_dir=
AC_ARG_WITH([numeric-path], 
AC_HELP_STRING([--with-numeric-path=PATH], [use PATH as the top-level directory for numeric [[$(python_prefix)/site-packages/Numeric]]]),
[AC_MSG_CHECKING([for top-level numeric directory])
if test "d$withval"; then
	AC_MSG_RESULT([$withval])
	numeric_path=$withval
	AC_SUBST([numeric_path])
else
	AC_MSG_ERROR([given numeric path $withval does not exist.])
fi])
AC_MSG_CHECKING([for top-level Numeric directory])
python_module_dir=${pyexecdir:15}
py_exec_prefix=`$PYTHON -c "import sys; print sys.exec_prefix"`
na_mod_numeric_path="$py_exec_prefix/$python_module_dir/Numeric"
if test -d $na_mod_numeric_path; then
	AC_MSG_RESULT([$na_mod_numeric_path])
	numeric_path=$na_mod_numeric_path
	AC_SUBST([numeric_path])
else
	AC_MSG_RESULT([not found])
fi])

dnl see if we can actually load the Numeric module
AC_DEFUN([NA_MOD_NUMERIC_IMPORT],
[na_mod_numeric_import=0
AC_MSG_CHECKING([for whether we can "import Numeric" or not])
na_mod_numeric_import=`$PYTHON -c "
try:
	import Numeric
	print 1
except ImportError:
	print 0"`
if test $na_mod_numeric_import -eq 1; then
	AC_MSG_RESULT([yes])
else
	AC_MSG_ERROR([unable to import Numeric])
	echo
	echo "I was unable to import the Numeric library, even though the"
	echo "correct directory seems to exist.  Check the output of config.log"
	echo "for more information."
fi])

dnl see if the matplotlib directory exists under "site-packages"
AC_DEFUN([NA_MOD_MATPLOTLIB_PATH],
[na_mod_matplotlib_dir=
AC_ARG_WITH([matplotlib-path], 
AC_HELP_STRING([--with-matplotlib-path=PATH], [use PATH as the top-level directory for matplotlib [[$(python_prefix)/site-packages/matplotlib]]]),
[AC_MSG_CHECKING([for top-level matplotlib directory])
if test "d$withval"; then
	AC_MSG_RESULT([$withval])
	matplotlib_path=$withval
	AC_SUBST([matplotlib_path])
else
	AC_MSG_ERROR([given matplotlib path $withval does not exist.])
fi])
AC_MSG_CHECKING([for top-level matplotlib directory])
python_module_dir=${pyexecdir:15}
py_exec_prefix=`$PYTHON -c "import sys; print sys.exec_prefix"`
na_mod_matplotlib_path="$py_exec_prefix/$python_module_dir/matplotlib"
if test -d $na_mod_matplotlib_path; then
	AC_MSG_RESULT([$na_mod_matplotlib_path])
	matplotlib_path=$na_mod_matplotlib_path
	AC_SUBST([matplotlib_path])
else
	AC_MSG_ERROR([unable to find the matplotlib module directory...I searched in $na_mod_matplotlib_path.] [You need matplotlib to install froi.  Please read the README file for more information.])
fi])

dnl see if we can actually load the matplotlib module
AC_DEFUN([NA_MOD_MATPLOTLIB_IMPORT],
[na_mod_matplotlib_import=0
AC_MSG_CHECKING([for whether we can "import matplotlib" or not])
na_mod_matplotlib_import=`$PYTHON -c "
try:
	import matplotlib
	print 1
except ImportError:
	print 0"`
if test $na_mod_matplotlib_import -eq 1; then
	AC_MSG_RESULT([yes])
else
	AC_MSG_ERROR([unable to import matplotlib])
	echo
	echo "I was unable to import the matplotlib library, even though the"
	echo "correct directory seems to exist.  Check the output of config.log"
	echo "for more information."
fi])

dnl a macro to check for ability to create python extensions
dnl  AM_CHECK_PYTHON_HEADERS([ACTION-IF-POSSIBLE], [ACTION-IF-NOT-POSSIBLE])
dnl function also defines PYTHON_INCLUDES
dnl taken from gst-python's acinclude.m4 (nak)
AC_DEFUN([AM_CHECK_PYTHON_HEADERS],
[AC_REQUIRE([AM_PATH_PYTHON])
AC_MSG_CHECKING(for headers required to compile python extensions)
dnl deduce PYTHON_INCLUDE
py_prefix=`$PYTHON -c "import sys; print sys.prefix"`
py_exec_prefix=`$PYTHON -c "import sys; print sys.exec_prefix"`
PYTHON_INCLUDES="-I${py_prefix}/include/python${PYTHON_VERSION}"
if test "$py_prefix" != "$py_exec_prefix"; then
	  PYTHON_INCLUDES="$PYTHON_INCLUDES -I${py_exec_prefix}/include/python${PYTHON_VERSION}"
fi
AC_SUBST(PYTHON_INCLUDES)
dnl check if the headers exist:
save_CPPFLAGS="$CPPFLAGS"
CPPFLAGS="$CPPFLAGS $PYTHON_INCLUDES"
AC_TRY_CPP([#include <Python.h>],dnl
	[AC_MSG_RESULT(found) $1],dnl
	[AC_MSG_RESULT(not found) $2])
CPPFLAGS="$save_CPPFLAGS"
])

dnl PY_CHECK_MODULES(MODULE [, SYMBOL [, ACTION-IF-FOUND [, ACTION-IF-NOT-FOUND]]])
dnl check if a module with said symbol is visible to python
dnl we do some name mangling to automatically create the output variables
dnl all "."s are converted to "_"s.
AC_DEFUN([PY_CHECK_MODULES],
[AC_REQUIRE([AM_PATH_PYTHON])
py_mod_var=`echo $1_$2 | sed 'y%./+-%__p_%'`
AC_MSG_CHECKING(for ifelse([$2],[],,[$2 in ])python module $1)
AC_CACHE_VAL(py_cv_mod_$py_mod_var, [
ifelse([$2],[], [prog="
import sys
try:
        import $1
except ImportError:
        sys.exit(1)
except:
        sys.exit(0)
sys.exit(0)"], [prog="
import sys
try:
	import $1
	
	try:
		$1.$2
	except AttributeError:
		try:
			import $1.$2
		except ImportError:
			sys.exit(1)
		sys.exit(0)

	sys.exit(0)
except ImportError:
	sys.exit(1)"])
if $PYTHON -c "$prog" 1>&AC_FD_CC 2>&AC_FD_CC
  then
    eval "py_cv_mod_$py_mod_var=yes"
  else
    eval "py_cv_mod_$py_mod_var=no"
  fi
])
py_val=`eval "echo \`echo '$py_cv_mod_'$py_mod_var\`"`
if test "x$py_val" != xno; then
  AC_MSG_RESULT(yes)
  ifelse([$3], [],, [$3
])dnl
else
  AC_MSG_RESULT(no)
  AC_MSG_ERROR([I was unable to find the Python module 'ifelse([$2],[], [$1], [$1.$2])'.  Please read the README file to find out how to install it.])
  ifelse([$4], [],, [$4
])dnl
fi
])
